-----------------------------------------------------------------
-- DeviceOne Lua Library
-- Version 1.0.0
-- Author : nanyuantingfeng
-----------------------------------------------------------------
return (function(_ENV)
    local require, pcall, pairs, ipairs, type, tostring, tonumber, getmetatable, setmetatable, rawset = require, pcall, pairs, ipairs, type, tostring, tonumber, getmetatable, setmetatable, rawset;
    local table, string, JSON = require "table", require "string", require "json";
    local byte, insert = string.byte, table.insert;
    local L, R, Fk, Fi, ME, M2, J2, I0, BA, BP, Class, DP, DM, d1, C, cc, E, Q, UI, SM, MM;
    L = {
        _0_ = function(m, e, p) return _ENV._do_ui_sync_invoke(m, e, p); end;
        _1_ = function(m, e, p, u) return _ENV._do_ui_async_invoke(m, e, p, u); end;
        _2_ = function(m, e, p) return _ENV._do_sm_sync_invoke(m, e, p); end;
        _3_ = function(m, e, p, u) return _ENV._do_sm_async_invoke(m, e, p, u); end;
        _4_ = function(m, e, p) return _ENV._do_mm_sync_invoke(m, e, p); end;
        _5_ = function(m, e, p, u) return _ENV._do_mm_async_invoke(m, e, p, u); end;
        _6_ = function(m, e, p) return _ENV._do_mm_createnew(m, e, p); end;
        _7_ = function(m) return _ENV._do_mm_release(m); end;
        _8_ = function(m, s) return _ENV._do_print(m, s); end;
    };
    R = {
        fz = {}; fm = {};
        h = function(a, b) if a[b] == nil then return false else return true end end;
        r = function(k) return { get = function(this, k) return this:get(k); end; } end;
        w = function(k) return { get = function(this, k) return this:get(k); end; set = function(this, k, v) return this:set(k, v); end; } end;
        p = function(a, b) return ME(a, b) end;
        l = function(a, b) return L._8_(tostring(a), tostring(b)) end
    };
    Fk = function(m, f)
        local _, y;
        m = m or {};
        for i, v in pairs(m) do
            _, y = pcall(f, i, v);
            if y == false then break; end
        end
        return m;
    end;
    Fi = function(m, f)
        local _, y;
        m = m or {};
        for i, v in ipairs(m) do
            _, y = pcall(f, i, v);
            if y == false then break; end
        end
        return m;
    end;
    I0 = function(m) return type(m) == "table"; end;
    ME = function(t, u, ...)
        if not t then t = {}; end
        if not u then return t; end
        for i, v in pairs(u) do t[i] = v; end
        return ME(t, ...)
    end;
    M2 = function(s)
        local n, c, g, x;
        if type(s) ~= "string" then do return s end end;
        n = s:find "%S"
        s = n and s:match(".*%S", n) or "";
        c = byte(s, 1);
        if c == 123 or c == 91 then g, x = pcall(JSON.decode, s); s = g and x or s; end
        return s;
    end;
    J2 = function(t) if I0(t) then return JSON.encode(t); end return t; end;
    BA = function(o) if (I0(o) and o._do_addressN) then return o:_do_addressN(); end; return o; end;
    BP = function(ags, als)
        local o, i, l, v, ast;
        if (ags == o or als == o) then return ""; end
        ast = BA(ags[1]);
        if (ast and I0(ast) and R.h(ast, als[1])) then
            for k, m in pairs(ast) do ast[k] = BA(m) end
            return ast;
        end
        l, o = #als, {};
        for i = 1, l do
            v = ags[i];
            if (type(v) == "function") then break; else o[als[i]] = BA(v); end
        end
        return o;
    end;
    Class = function(Super, init)
        local NEW = { fz = {}, fm = {} };
        init = init or function() end;
        for i, v in pairs(Super.fm or {}) do NEW.fm[i] = v; end;
        NEW.fm.__index = function(this, k)
            if (not (I0(this.fz[k]) and this.fz[k] and this.fz[k].get)) then return this.fz[k]; end
            local get = this.fz[k].get;
            if (get) then return get(this, k); end
        end;
        NEW.fm.__newindex = function(this, k, v)
            if (I0(this.fz[k]) and this.fz[k] and not this.fz[k].set) then return nil; end
            if (not (I0(this.fz[k]) and this.fz[k] and this.fz[k].set)) then return rawset(this, k, v); end
            local set = this.fz[k].set;
            if (set) then return set(this, k, v); end
        end
        NEW.fm.__call = function(self, ...)
            local this = {};
            for i, v in pairs(self) do this[i] = v; end;
            init(this, ...);
            return setmetatable(this, getmetatable(self));
        end;
        setmetatable(NEW.fz, { __index = function(_, key) return Super.fz[key] end; });
        NEW.initialize = init;
        return setmetatable(NEW, NEW.fm);
    end
    DP = function(fz, ro, rw)
        local fzz = {};
        Fi(ro, function(i, v) fzz[v] = R.r(v) end);
        Fi(rw, function(i, v) fzz[v] = R.w(v) end);
        return R.p(fz, fzz);
    end;
    DM = function(fz, ms, ma)
        Fk(ms, function(k, v) fz[k] = function(this, ...) return this:_do_synchrN(k, { ... }, v); end end);
        Fk(ma, function(k, v) fz[k] = function(this, ...) return this:_do_asynchN(k, { ... }, v); end end);
        return fz;
    end;
    d1 = { Class = Class, foreach = Fk, foreachi = Fi, merge = ME, print = R.l };
    C = Class(R, function(this)
        this._S_ = {};
        this._F_ = {};
        this._E_ = {};
    end);
    ME(C.fz, {
        uid = (function()
            local _uux = 0xFFFFEEEF;
            return function() _uux = _uux + 1; return tostring(_uux); end
        end)(),
        reg = function(this, s, e, m, f)
            local g, u, q = { e = e, u = "-" }, nil, nil;
            if (type(f) ~= "function") then return g; end
            u = this:uid();
            this._S_[u] = s;
            this._F_[u] = f;
            g.u = u;
            if not (e == "on") then return g; end
            q = s._do_uniqueN;
            this._E_[q] = this._E_[q] or {};
            this._E_[q][m.name] = this._E_[q][m.name] or {};
            insert(this._E_[q][m.name], u);
            return g;
        end,
        del = function(this, u)
            this._F_[u] = nil;
            this._S_[u] = nil;
            return this;
        end,
        ivk = function(this, r)
            local g = M2(r.callback);
            local f = this._F_[g.u];
            if (f) then pcall(f, M2(r.data), { code = r.code, message = r.message, data = M2(r.eventdata), sender = r.sender }, this._S_[g.u]); end
            if g.e ~= "on" then this:del(g.u); end
            return this;
        end,
        off = function(this, s, e)
            local q, se = s._do_uniqueN, nil;
            if (this._E_[q]) then
                if (this._E_[q][e]) then
                    se = this._E_[q][e];
                    for i, v in ipairs(se) do this:del(se[i]); end
                end
                this._E_[q][e] = nil;
            end
            return s;
        end,
        uis = function(this, s, e, m) return M2(M2(L._0_(s._do_uniqueN, e, J2(m))).data); end,
        uia = function(this, s, e, m, f) L._1_(s._do_uniqueN, e, J2(m), J2(this:reg(s, e, m, f))); return s; end,
        sms = function(this, s, e, m) return M2(M2(L._2_(s._do_uniqueN, e, J2(m))).data); end,
        sma = function(this, s, e, m, f) L._3_(s._do_uniqueN, e, J2(m), J2(this:reg(s, e, m, f))); return s; end,
        mms = function(this, s, e, m) return M2(M2(L._4_(s._do_uniqueN, e, J2(m))).data); end,
        mma = function(this, s, e, m, f) L._5_(s._do_uniqueN, e, J2(m), J2(this:reg(s, e, m, f))); return s; end,
        mmn = function(this, s, e, m) return M2(L._6_(s, e, m)).data; end,
        mmd = function(this, s) return L._7_(s._do_uniqueN); end,
        err = function(this, s) return L._8_(s, "ERROR"); end,
    });
    cc = C();
    _ENV._do_async_callback = function(r) cc:ivk(M2(r)); end;
    E = Class(R);
    ME(E.fz, {
        on = function(this, ...) return this:_do_asynchN("on", { ... }, { "name", "data", "delay" }); end,
        off = function(this, ...)
            local arg = { ... }
            this:_do_synchrN("off", arg, { "name" });
            return cc:off(this, arg[1]);
        end,
        fire = function(this, ...) return this:_do_synchrN("fire", { ... }, { "name", "data" }); end,
        getAddress = function(this) return this:_do_synchrN("getAddress"); end,
        getType = function(this) return this:_do_synchrN("getType"); end,
        _do_addressN = function(this) return this._do_uniqueN; end
    });
    Q = Class(E);
    ME(Q.fz, {
        get = function(this, ...)
            local arg, flg = { ... }, nil;
            flg = not (I0(arg[1]) and #arg[1] ~= 0);
            if (flg) then arg[1] = { arg[1] }; end
            local _n = this:_do_synchrN("get", arg, { "data" });
            if _n == nil then return cc.err "Failed to get properties" .. J2(arg); end
            if (flg) then _n = _n[arg[1][1]]; end
            return _n;
        end,
        set = function(this, ...)
            local arg, kv = { ... }, {};
            if (#arg >= 2) then kv[arg[1]] = BA(arg[2]); else kv = arg[1] end
            return this:_do_synchrN("set", { kv }, { "data" });
        end,
        bindData = function(this, ...) return this:_do_synchrN("bindData", { ... }, { "data", "mapping" }) end,
        setMapping = function(this, ...) return this:_do_synchrN("setMapping", { ... }, { "data" }) end,
        refreshData = function(this) return this:_do_synchrN("refreshData") end,
    });
    UI, SM, MM = Class(Q), Class(E), Class(Q);
    d1.UI, d1.SM, d1.MM = UI, SM, MM;
    DP(UI.fz, { "id" }, { "width", "height", "x", "y", "visible", "alpha", "bgColor", "tag", "margin" });
    ME(UI.fz, {
        animate = function(this, ...) return this:_do_asynchN("animate", { ... }, { "animation" }); end,
        remove = function(this) return this:_do_synchrN("remove"); end,
        redraw = function(this) return this:_do_synchrN("redraw"); end,
        getRect = function(this) return this:_do_synchrN("getRect"); end,
        _do_synchrN = function(this, e, a, l) return cc:uis(this, e, BP(a, l)); end,
        _do_asynchN = function(this, e, a, l) return cc:uia(this, e, BP(a, l), a[#a]); end
    });
    ME(SM.fz, {
        _do_synchrN = function(this, e, a, l) return cc:sms(this, e, BP(a, l)); end,
        _do_asynchN = function(this, e, a, l) return cc:sma(this, e, BP(a, l), a[#a]); end
    });
    ME(MM.fz, {
        load = function(this, ...) return this:_do_asynchN("load", { ... }, { "source" }); end,
        release = function(this) return cc:mmd(this); end,
        _do_synchrN = function(this, e, a, l) return cc:mms(this, e, BP(a, l)); end,
        _do_asynchN = function(this, e, a, l) return cc:mma(this, e, BP(a, l), a[#a]); end
    });
    d1.ui = function(m)
        local a4 = cc:uis({ _do_uniqueN = m }, "getInit", "");
        if not a4 then return cc:err "Failed to get information [" .. m .. "]"; end
        if not UI[a4.type] then return cc:err "Class UI." .. a4.type .. " has not been defined"; end
        return UI[a4.type](a4);
    end;
    d1.sm = function(m)
        if not SM[m] then return cc:err "Class SM." .. m .. " has not been defined"; end;
        return SM[m]();
    end
    d1.mm = function(m, i, c)
        if not MM[m] then return cc:err "Class MM." .. m .. " has not been defined"; end;
        return MM[m](BA(i or ""), BA(c or ""));
    end;
    UI.df = function(n, ro, rw, ms, ma)
        UI[n] = Class(UI, function(this, a4) this._do_uniqueN = a4.address end);
        DM(DP(UI[n].fz, ro, rw), ms, ma);
    end;
    SM.df = function(n, ms, ma)
        SM[n] = Class(SM, function(this) this._do_uniqueN = cc:sms({ _do_uniqueN = n }, "getAddress", "") end);
        DM(SM[n].fz, ms, ma);
    end;
    MM.df = function(n, ro, rw, ms, ma)
        MM[n] = Class(MM, function(this, i, c) this._do_uniqueN = cc:mmn(n, i, c) end);
        DM(DP(MM[n].fz, ro, rw), ms, ma);
    end;
SM.df("do_Album",{},{save={"path","name","width","height","quality"},select={"maxCount","width","height","quality"}});
SM.df("do_Alipay",{},{pay={"rsaPrivate","rsaPublic","partner","notifyUrl","tradeNo","subject","sellerId","totalFee","body","timeOut"}});
SM.df("do_Audio",{pause={},play={"path","point"},resume={},startRecord={"path","type","quality","limit"},stop={},stopRecord={}},{});
UI.df("do_BaiduMapView",{},{"zoomLevel"},{addMarkers={"data"},removeAll={},removeMarker={"ids"},setCenter={"latitude","longitude"}},{});
SM.df("do_BaiduPush",{startWork={},stopWork={}},{});
UI.df("do_BarcodeView",{},{},{},{start={}});
SM.df("do_Bluetooth",{},{close={},open={},sendData={"data"},sendFile={"path"}});
UI.df("do_Button",{"radius","textFlag"},{"bgImage","enabled","fontColor","fontSize","fontStyle","text"},{},{});
SM.df("do_Camera",{},{capture={"width","height","quality","iscut"}});
UI.df("do_CheckBox",{},{"checked","enabled","fontColor","fontSize","fontStyle","text","textFlag"},{},{});
UI.df("do_ComboBox",{"textFlag"},{"fontColor","fontSize","fontStyle","index","items"},{},{});
SM.df("do_DataCache",{loadData={"key"},saveData={"key","value"}},{});
SM.df("do_DateTimePicker",{},{show={"type","data","maxDate","minDate","title","buttons"}});
SM.df("do_Device",{beep={},flash={"status"},getAllAppInfo={},getInfo={"name"},vibrate={"duration"}},{});
UI.df("do_do_IndexListView",{"selectedColor","templates"},{},{bindItems={"data"},refreshItems={}},{});
SM.df("do_External",{installApp={"path"},openApp={"wakeupid","data"},openContact={},openDial={"number"},openMail={"to","subject","body"},openSMS={"number","body"},openURL={"url"}},{});
UI.df("do_FragmentView",{"leftpage","leftwidth","middlepage","rightpage","rightwidth"},{},{showLeftPage={},showRightPage={}},{});
UI.df("do_FrameAnimationView",{},{},{startGif={"data","repeat"},startImages={"data","repeat"},stop={}},{});
UI.df("do_GridView",{"hSpacing","isShowbar","numColumns","selectedColor","templates","vSpacing"},{},{bindItems={"data"},refreshItems={}},{});
MM.df("do_HashData",{},{},{addData={"data"},addOne={"key","value"},getAll={},getCount={},getData={"keys"},getOne={"key"},removeAll={},removeData={"keys"},removeOne={"key"}},{});
MM.df("do_Http",{},{"body","contentType","method","timeout","url"},{download={"path"},request={},upload={"path","name"}},{});
SM.df("do_HuanXinIM",{enterChat={"userID","userNick","userIcon","selfNick","selfIcon","tag"},logout={}},{login={"username","password"}});
SM.df("do_iFlyVoice",{pause={},resume={},speak={"text","role"},stop={}},{open={}});
SM.df("do_ImageBrowser",{show={"data","index"}},{});
UI.df("do_ImageView",{"cacheType","radius","scale"},{"defaultImage","enabled","source"},{},{});
UI.df("do_Label",{"maxHeight","maxLines","maxWidth","textAlign","textFlag"},{"fontColor","fontSize","fontStyle","text"},{},{});
MM.df("do_ListData",{},{},{addData={"data","index"},addOne={"data","index"},getCount={},getData={"indexs"},getOne={"index"},getRange={"fromIndex","toIndex"},removeAll={},removeData={"indexs"},removeRange={"fromIndex","toIndex"},updateOne={"index","data"}},{});
UI.df("do_ListView",{"footerView","headerView","isFooterVisible","isHeaderVisible","isShowbar","selectedColor","templates"},{},{bindItems={"data"},rebound={},refreshItems={}},{});
SM.df("do_Network",{getIP={},getOperators={},getStatus={}},{});
SM.df("do_Notification",{},{alert={"text","title"},confirm={"text","title","button1text","button2text"},toast={"text"}});
UI.df("do_ProgressBar",{"style"},{"progress"},{},{});
UI.df("do_RichLabel",{},{"fontColor","fontSize","fontStyle","maxHeight","maxLines","maxWidth","text","textAlign"},{},{});
UI.df("do_ScrollView",{"direction","headerView","isHeaderVisible","isShowbar"},{},{rebound={},toBegin={},toEnd={}},{});
UI.df("do_SegmentView",{},{"index","templates"},{bindItems={"data"},refreshItems={}},{});
SM.df("do_SinaWeiBo",{},{getUserInfo={"uid","accessToken","refreshToken","expires"},login={"appId"},logout={},share={"appID","type","title","image","url","summary"}});
UI.df("do_SlideView",{"looping","templates"},{"index"},{bindItems={"data"},refreshItems={}},{});
MM.df("do_Socket",{},{},{close={}},{connect={"ip","port"},send={"data"}});
MM.df("do_SQLite",{},{"path","sql"},{close={},executeSync={"sql"},open={"path"}},{execute={"sql"},query={"sql"}});
UI.df("do_SwitchView",{},{"checked"},{},{});
SM.df("do_TencentQQ",{},{getUserInfo={"token","expires","openId"},login={"appId"},logout={},shareToQQ={"appId","type","title","url","image","summary","audio","appName"},shareToQzone={"appId","type","title","url","image","summary"}});
SM.df("do_TencentWX",{},{login={"appId"},pay={"appId","partnerId","prepayId","package","nonceStr","timeStamp","sign"},share={"appId","scene","type","title","content","url","image","audio"}});
UI.df("do_TextBox",{"maxLength","textFlag"},{"fontColor","fontSize","fontStyle","hint","text"},{},{});
UI.df("do_TextField",{"clearAll","inputType","password","textFlag"},{"fontColor","fontSize","fontStyle","hint","text"},{},{});
MM.df("do_Timer",{},{"delay","interval"},{start={},stop={}},{});
SM.df("do_UMengAnalytics",{beginPageLog={"pageName"},endPageLog={"pageName"},eventLog={"id","data"},eventValueLog={"id","data","counter"},readConfig={"configID"},reportPolicy={"type"},setBackgroundTask={"value"},setCrashReportEnabled={"value"},setEncryptLog={"value"}},{});
UI.df("do_VideoView",{},{"path"},{pause={},play={"point"},resume={},stop={}},{});
UI.df("do_ViewShower",{},{},{addViews={"data"},removeView={"id"},showView={"id","animationType","animationTime"}},{});
UI.df("do_ALayout",{"allowGesture","isStretch","layoutAlign"},{"enabled","bgImage","bgImageFillType"},{add={"id","path","x","y"}},{});
MM.df("do_Animation",{},{"fillAfter"},{alpha={"data","id"},transfer={"data","id"},scale={"data","id"},rotate={"data","id"}},{});
SM.df("do_App",{getAppID={}},{openPage={"source","data","animationType","isFullScreen","keyboardMode","scriptType","statusBarBgColor","statusBarFgColor"},closePage={"data","animationType"}});
MM.df("do_DataModel",{},{"dataSource","cacheID"},{fetchData={}},{});
MM.df("do_File",{},{"source"},{},{read={},write={"data"}});
SM.df("do_Global",{getTime={"format"},getWakeupID={},getVersion={},getMemory={"key"},setMemory={"key","value"},exit={},setToPasteboard={"data"},getFromPasteboard={}},{install={"src"}});
UI.df("do_LinearLayout",{"direction","padding"},{"enabled","bgImage","bgImageFillType"},{add={"id","path","target"}},{});
SM.df("do_Page",{getData={},remove={"id"},hideKeyboard={}},{});
SM.df("do_Storage",{dirExist={"path"},fileExist={"path"}},{getFiles={"path"},getDirs={"path"},deleteDir={"path"},deleteFile={"path"},readFile={"path"},writeFile={"path","data"},zip={"source","target"},zipFiles={"source","target"},unzip={"source","target"},copy={"source","target"}});
UI.df("do_WebView",{"isHeaderVisible","headerView","zoom"},{"url"},{back={},forward={},reload={},stop={},canForward={},canBack={},rebound={}},{loadString={"text"}});
    return d1;
end)(_ENV);
