/**
 * json转换
 * @Author : Cydow
 * @Timestamp : 2017-03-24
 */
//引入组件库
var deviceone = require("deviceone");

/**
 * json对象转换成字符串
 * @param _jsonObj
 * @returns
 */
function jsonObjToStr(_jsonObj){
	return JSON.stringify(_jsonObj);
}

//json对象转换成字符串
module.exports.jsonObjToStr = function(_jsonObj){
	return jsonObjToStr(_jsonObj);
}

/**
 * 字符串转换成json对象
 * @param _str
 * @returns
 */
function strToJsonObj(_str){
	if(null == _str || 
			"" == _str || 
			"{}" == _str){
		return null;
	}
	try {
		var _jsonObj = JSON.parse(_str);
	} catch (e) {
		// TODO: handle exception
		return null;
	}
	return _jsonObj;
}

//字符串转换成json对象
module.exports.strToJsonObj = function(_str){
	return strToJsonObj(_str);
}